Bug 1489451 - Catalog patch breaks linuxdoc-tools
Summary: Catalog patch breaks linuxdoc-tools
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: docbook-dtds
Version: 33
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Ondrej Vasik
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-09-07 13:23 UTC by Guillaume Rousse
Modified: 2020-11-05 18:30 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)

Description Guillaume Rousse 2017-09-07 13:23:49 UTC
The docbook-dtds package patches docbook SGML catalogs to remove ISO entities declarations, and replace DTDDECL statement with SGMLDECL statement for docbook 3.0, 3.1, 4.0 and 4.1:
- https://src.fedoraproject.org/rpms/docbook-dtds/blob/master/f/docbook-dtd30-sgml-1.0.catalog.patch
- https://src.fedoraproject.org/rpms/docbook-dtds/blob/master/f/docbook-dtd31-sgml-1.0.catalog.patch
- https://src.fedoraproject.org/rpms/docbook-dtds/blob/master/f/docbook-dtd40-sgml-1.0.catalog.patch
- https://src.fedoraproject.org/rpms/docbook-dtds/blob/master/f/docbook-dtd41-sgml-1.0.catalog.patch

Unfortunately, this also has the unexpected side effect of breaking linuxdoc-tools processing when this package is also installed.

Without docbook-dtds installed:
[guillaume@sp linuxdoc-tools-0.9.72]$ /usr/local/bin/linuxdoc -B html doc/guide.sgml 
Processing file doc/guide.sgml
-> OK

With docbook-dtds installed:
[guillaume@sp linuxdoc-tools-0.9.72]$ LC_ALL=C /usr/local/bin/linuxdoc -B html doc/guide.sgml 
Processing file doc/guide.sgml
nsgmls:<OSFD>0:8:8:E: document type does not allow element "ARTICLE" here; assuming missing "LINUXDOC" start-tag
nsgmls:<OSFD>0:10:6:E: document type does not allow element "TITLE" here; assuming missing "TITLEPAG" start-tag
nsgmls:<OSFD>0:11:7:E: document type does not allow element "AUTHOR" here
nsgmls:<OSFD>0:19:5:E: document type does not allow element "DATE" here
nsgmls:<OSFD>0:20:9:E: document type does not allow element "ABSTRACT" here
nsgmls:<OSFD>0:29:4:E: document type does not allow element "TOC" here
nsgmls:<OSFD>0:31:5:E: document type does not allow element "SECT" here
nsgmls:<OSFD>0:31:6:E: character data is not allowed here
...
-> failure

It seems the problem comes from multiple occurrences of SGMLDECL "docbook.dcl" statements when loading the global SGML catalog. Commenting out offending docbook catalogs (4.2 and new versions are not affected), or reverting the problematic part of the patch is enough to fix. I don't have enough SGML knowledge to understand if the root issue comes from redhat package changes, or linuxdoc-tools itself.

I tested the issue on Centos and Mageia, not on Fedora directly, but that's the same package and the same patch.

Comment 1 Fedora End Of Life 2018-02-20 15:21:30 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 28 development cycle.
Changing version to '28'.

Comment 2 Sammy 2018-02-25 22:27:20 UTC
This bug is still there on Fedora 27 and causing problems whenever linuxdoc is to be used. Solution is needed.

Comment 3 Jakub Hrozek 2018-06-08 13:32:10 UTC
It would be really nice if this bug was fixed. I can't build libuser from source w/o workarounds due to the issue.

Comment 4 Ondrej Vasik 2018-06-11 15:54:18 UTC
Ok, will try to drop replacement of DTDDECL statement with SGMLDECL statement - it is not present in 4.2+ sgml catalogs anyway - and I see no reason for it. Anyway, there was one more typo (sgml docbook 3.0 instead of 3.1 in one of the patch) - fixed together. Sorry for delay. Built in Rawhide...

Comment 5 Sammy 2018-06-14 13:09:54 UTC
I buuilt docbook-dtds-1.0-70 on Fedora 28 and it did not resolve my problem. I am still getting problem with SECT when compiling an application:

Processing file FAQ.sgml
nsgmls:<OSFD>0:228:7:E: document type does not allow element "SECT" here
nsgmls:<OSFD>0:239:7:E: document type does not allow element "SECT" here
nsgmls:<OSFD>0:311:7:E: document type does not allow element "SECT" here
nsgmls:<OSFD>0:352:7:E: document type does not allow element "SECT" here
nsgmls:<OSFD>0:434:9:E: end tag for "ITEMIZE" omitted, but its declaration does not permit this
nsgmls:<OSFD>0:203:8: start tag was here
LinuxdocTools::process_file: nsgmls failed with exit status 1. Aborting ...

Removing docbook-dtds rpm temporarily allows for compilation.

Comment 6 Ben Cotton 2019-05-02 21:35:07 UTC
This message is a reminder that Fedora 28 is nearing its end of life.
On 2019-May-28 Fedora will stop maintaining and issuing updates for
Fedora 28. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora 'version' of '28'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 28 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 7 Ben Cotton 2019-08-13 16:47:12 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 8 Ben Cotton 2020-11-03 14:59:09 UTC
This message is a reminder that Fedora 31 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 31 on 2020-11-24.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '31'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 31 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 9 Patrick Monnerat 2020-11-05 18:30:35 UTC
3 years later: still not fixed in F33 :-(


Note You need to log in before you can comment on or make changes to this bug.